Josh Poimboeuf | 6732666 | 2016-09-19 10:52:14 -0500 | [diff] [blame] | 1 | #!/bin/bash |
Greg Kroah-Hartman | b244131 | 2017-11-01 15:07:57 +0100 | [diff] [blame] | 2 | # SPDX-License-Identifier: GPL-2.0 |
Josh Poimboeuf | 6732666 | 2016-09-19 10:52:14 -0500 | [diff] [blame] | 3 | # |
| 4 | # Translate stack dump function offsets. |
| 5 | # |
| 6 | # addr2line doesn't work with KASLR addresses. This works similarly to |
| 7 | # addr2line, but instead takes the 'func+0x123' format as input: |
| 8 | # |
| 9 | # $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568 |
| 10 | # meminfo_proc_show+0x5/0x568: |
| 11 | # meminfo_proc_show at fs/proc/meminfo.c:27 |
| 12 | # |
| 13 | # If the address is part of an inlined function, the full inline call chain is |
| 14 | # printed: |
| 15 | # |
| 16 | # $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27 |
| 17 | # native_write_msr+0x6/0x27: |
| 18 | # arch_static_branch at arch/x86/include/asm/msr.h:121 |
| 19 | # (inlined by) static_key_false at include/linux/jump_label.h:125 |
| 20 | # (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125 |
| 21 | # |
| 22 | # The function size after the '/' in the input is optional, but recommended. |
| 23 | # It's used to help disambiguate any duplicate symbol names, which can occur |
| 24 | # rarely. If the size is omitted for a duplicate symbol then it's possible for |
| 25 | # multiple code sites to be printed: |
| 26 | # |
| 27 | # $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5 |
| 28 | # raw_ioctl+0x5/0x20: |
| 29 | # raw_ioctl at drivers/char/raw.c:122 |
| 30 | # |
| 31 | # raw_ioctl+0x5/0xb1: |
| 32 | # raw_ioctl at net/ipv4/raw.c:876 |
| 33 | # |
| 34 | # Multiple addresses can be specified on a single command line: |
| 35 | # |
| 36 | # $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 free_reserved_area+0x90 |
| 37 | # type_show+0x10/0x2d: |
| 38 | # type_show at drivers/video/backlight/backlight.c:213 |
| 39 | # |
| 40 | # free_reserved_area+0x90/0x123: |
| 41 | # free_reserved_area at mm/page_alloc.c:6429 (discriminator 2) |
| 42 | |
| 43 | |
| 44 | set -o errexit |
| 45 | set -o nounset |
| 46 | |
Liu, Changcheng | 4cc90b4 | 2017-12-14 15:32:48 -0800 | [diff] [blame] | 47 | READELF="${CROSS_COMPILE:-}readelf" |
| 48 | ADDR2LINE="${CROSS_COMPILE:-}addr2line" |
| 49 | SIZE="${CROSS_COMPILE:-}size" |
| 50 | NM="${CROSS_COMPILE:-}nm" |
Liu, Changcheng | 95a8798 | 2017-11-29 16:10:25 -0800 | [diff] [blame] | 51 | |
Josh Poimboeuf | 6732666 | 2016-09-19 10:52:14 -0500 | [diff] [blame] | 52 | command -v awk >/dev/null 2>&1 || die "awk isn't installed" |
Liu, Changcheng | 95a8798 | 2017-11-29 16:10:25 -0800 | [diff] [blame] | 53 | command -v ${READELF} >/dev/null 2>&1 || die "readelf isn't installed" |
| 54 | command -v ${ADDR2LINE} >/dev/null 2>&1 || die "addr2line isn't installed" |
| 55 | command -v ${SIZE} >/dev/null 2>&1 || die "size isn't installed" |
| 56 | command -v ${NM} >/dev/null 2>&1 || die "nm isn't installed" |
Josh Poimboeuf | 6732666 | 2016-09-19 10:52:14 -0500 | [diff] [blame] | 57 | |
| 58 | usage() { |
| 59 | echo "usage: faddr2line <object file> <func+offset> <func+offset>..." >&2 |
| 60 | exit 1 |
| 61 | } |
| 62 | |
| 63 | warn() { |
| 64 | echo "$1" >&2 |
| 65 | } |
| 66 | |
| 67 | die() { |
| 68 | echo "ERROR: $1" >&2 |
| 69 | exit 1 |
| 70 | } |
| 71 | |
| 72 | # Try to figure out the source directory prefix so we can remove it from the |
| 73 | # addr2line output. HACK ALERT: This assumes that start_kernel() is in |
| 74 | # kernel/init.c! This only works for vmlinux. Otherwise it falls back to |
| 75 | # printing the absolute path. |
| 76 | find_dir_prefix() { |
| 77 | local objfile=$1 |
| 78 | |
Liu, Changcheng | 95a8798 | 2017-11-29 16:10:25 -0800 | [diff] [blame] | 79 | local start_kernel_addr=$(${READELF} -sW $objfile | awk '$8 == "start_kernel" {printf "0x%s", $2}') |
Josh Poimboeuf | 6732666 | 2016-09-19 10:52:14 -0500 | [diff] [blame] | 80 | [[ -z $start_kernel_addr ]] && return |
| 81 | |
Liu, Changcheng | 95a8798 | 2017-11-29 16:10:25 -0800 | [diff] [blame] | 82 | local file_line=$(${ADDR2LINE} -e $objfile $start_kernel_addr) |
Josh Poimboeuf | 6732666 | 2016-09-19 10:52:14 -0500 | [diff] [blame] | 83 | [[ -z $file_line ]] && return |
| 84 | |
| 85 | local prefix=${file_line%init/main.c:*} |
| 86 | if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then |
| 87 | return |
| 88 | fi |
| 89 | |
| 90 | DIR_PREFIX=$prefix |
| 91 | return 0 |
| 92 | } |
| 93 | |
| 94 | __faddr2line() { |
| 95 | local objfile=$1 |
| 96 | local func_addr=$2 |
| 97 | local dir_prefix=$3 |
| 98 | local print_warnings=$4 |
| 99 | |
| 100 | local func=${func_addr%+*} |
| 101 | local offset=${func_addr#*+} |
| 102 | offset=${offset%/*} |
| 103 | local size= |
| 104 | [[ $func_addr =~ "/" ]] && size=${func_addr#*/} |
| 105 | |
| 106 | if [[ -z $func ]] || [[ -z $offset ]] || [[ $func = $func_addr ]]; then |
| 107 | warn "bad func+offset $func_addr" |
| 108 | DONE=1 |
| 109 | return |
| 110 | fi |
| 111 | |
| 112 | # Go through each of the object's symbols which match the func name. |
| 113 | # In rare cases there might be duplicates. |
Liu, Changcheng | 95a8798 | 2017-11-29 16:10:25 -0800 | [diff] [blame] | 114 | file_end=$(${SIZE} -Ax $objfile | awk '$1 == ".text" {print $2}') |
Josh Poimboeuf | 6732666 | 2016-09-19 10:52:14 -0500 | [diff] [blame] | 115 | while read symbol; do |
| 116 | local fields=($symbol) |
Josh Poimboeuf | efdb416 | 2016-10-25 09:51:11 -0500 | [diff] [blame] | 117 | local sym_base=0x${fields[0]} |
| 118 | local sym_type=${fields[1]} |
NeilBrown | 2aab9c3 | 2017-10-12 14:22:04 +1100 | [diff] [blame] | 119 | local sym_end=${fields[3]} |
Josh Poimboeuf | efdb416 | 2016-10-25 09:51:11 -0500 | [diff] [blame] | 120 | |
| 121 | # calculate the size |
| 122 | local sym_size=$(($sym_end - $sym_base)) |
| 123 | if [[ -z $sym_size ]] || [[ $sym_size -le 0 ]]; then |
| 124 | warn "bad symbol size: base: $sym_base end: $sym_end" |
| 125 | DONE=1 |
| 126 | return |
| 127 | fi |
| 128 | sym_size=0x$(printf %x $sym_size) |
Josh Poimboeuf | 6732666 | 2016-09-19 10:52:14 -0500 | [diff] [blame] | 129 | |
| 130 | # calculate the address |
| 131 | local addr=$(($sym_base + $offset)) |
| 132 | if [[ -z $addr ]] || [[ $addr = 0 ]]; then |
| 133 | warn "bad address: $sym_base + $offset" |
| 134 | DONE=1 |
| 135 | return |
| 136 | fi |
Josh Poimboeuf | efdb416 | 2016-10-25 09:51:11 -0500 | [diff] [blame] | 137 | addr=0x$(printf %x $addr) |
Josh Poimboeuf | 6732666 | 2016-09-19 10:52:14 -0500 | [diff] [blame] | 138 | |
| 139 | # weed out non-function symbols |
Josh Poimboeuf | efdb416 | 2016-10-25 09:51:11 -0500 | [diff] [blame] | 140 | if [[ $sym_type != t ]] && [[ $sym_type != T ]]; then |
Josh Poimboeuf | 6732666 | 2016-09-19 10:52:14 -0500 | [diff] [blame] | 141 | [[ $print_warnings = 1 ]] && |
Josh Poimboeuf | efdb416 | 2016-10-25 09:51:11 -0500 | [diff] [blame] | 142 | echo "skipping $func address at $addr due to non-function symbol of type '$sym_type'" |
Josh Poimboeuf | 6732666 | 2016-09-19 10:52:14 -0500 | [diff] [blame] | 143 | continue |
| 144 | fi |
| 145 | |
| 146 | # if the user provided a size, make sure it matches the symbol's size |
| 147 | if [[ -n $size ]] && [[ $size -ne $sym_size ]]; then |
| 148 | [[ $print_warnings = 1 ]] && |
Josh Poimboeuf | efdb416 | 2016-10-25 09:51:11 -0500 | [diff] [blame] | 149 | echo "skipping $func address at $addr due to size mismatch ($size != $sym_size)" |
Josh Poimboeuf | 6732666 | 2016-09-19 10:52:14 -0500 | [diff] [blame] | 150 | continue; |
| 151 | fi |
| 152 | |
| 153 | # make sure the provided offset is within the symbol's range |
| 154 | if [[ $offset -gt $sym_size ]]; then |
| 155 | [[ $print_warnings = 1 ]] && |
Josh Poimboeuf | efdb416 | 2016-10-25 09:51:11 -0500 | [diff] [blame] | 156 | echo "skipping $func address at $addr due to size mismatch ($offset > $sym_size)" |
Josh Poimboeuf | 6732666 | 2016-09-19 10:52:14 -0500 | [diff] [blame] | 157 | continue |
| 158 | fi |
| 159 | |
| 160 | # separate multiple entries with a blank line |
| 161 | [[ $FIRST = 0 ]] && echo |
| 162 | FIRST=0 |
| 163 | |
Josh Poimboeuf | efdb416 | 2016-10-25 09:51:11 -0500 | [diff] [blame] | 164 | # pass real address to addr2line |
| 165 | echo "$func+$offset/$sym_size:" |
Changbin Du | 6870c01 | 2018-04-05 16:18:29 -0700 | [diff] [blame] | 166 | local file_lines=$(${ADDR2LINE} -fpie $objfile $addr | sed "s; $dir_prefix\(\./\)*; ;") |
| 167 | [[ -z $file_lines ]] && return |
| 168 | |
| 169 | # show each line with context |
| 170 | echo "$file_lines" | while read -r line |
| 171 | do |
| 172 | echo $line |
Changbin Du | 78eb0c6 | 2018-05-11 16:02:11 -0700 | [diff] [blame^] | 173 | n=$(echo $line | sed 's/.*:\([0-9]\+\).*/\1/g') |
| 174 | n1=$[$n-5] |
| 175 | n2=$[$n+5] |
| 176 | f=$(echo $line | sed 's/.*at \(.\+\):.*/\1/g') |
Changbin Du | 6870c01 | 2018-04-05 16:18:29 -0700 | [diff] [blame] | 177 | awk 'NR>=strtonum("'$n1'") && NR<=strtonum("'$n2'") {printf("%d\t%s\n", NR, $0)}' $f |
| 178 | done |
| 179 | |
Josh Poimboeuf | 6732666 | 2016-09-19 10:52:14 -0500 | [diff] [blame] | 180 | DONE=1 |
| 181 | |
Liu, Changcheng | 95a8798 | 2017-11-29 16:10:25 -0800 | [diff] [blame] | 182 | done < <(${NM} -n $objfile | awk -v fn=$func -v end=$file_end '$3 == fn { found=1; line=$0; start=$1; next } found == 1 { found=0; print line, "0x"$1 } END {if (found == 1) print line, end; }') |
Josh Poimboeuf | 6732666 | 2016-09-19 10:52:14 -0500 | [diff] [blame] | 183 | } |
| 184 | |
| 185 | [[ $# -lt 2 ]] && usage |
| 186 | |
| 187 | objfile=$1 |
| 188 | [[ ! -f $objfile ]] && die "can't find objfile $objfile" |
| 189 | shift |
| 190 | |
| 191 | DIR_PREFIX=supercalifragilisticexpialidocious |
| 192 | find_dir_prefix $objfile |
| 193 | |
| 194 | FIRST=1 |
| 195 | while [[ $# -gt 0 ]]; do |
| 196 | func_addr=$1 |
| 197 | shift |
| 198 | |
| 199 | # print any matches found |
| 200 | DONE=0 |
| 201 | __faddr2line $objfile $func_addr $DIR_PREFIX 0 |
| 202 | |
| 203 | # if no match was found, print warnings |
| 204 | if [[ $DONE = 0 ]]; then |
| 205 | __faddr2line $objfile $func_addr $DIR_PREFIX 1 |
| 206 | warn "no match for $func_addr" |
| 207 | fi |
| 208 | done |